/**
 * WS-Attacker - A Modular Web Services Penetration Testing Framework Copyright
 * (C) 2010 Christian Mainka
 *
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 51
 * Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 */
package wsattacker.gui.component.testrequest.header;

import com.eviware.soapui.impl.wsdl.submit.transports.http.WsdlResponse;
import com.eviware.soapui.support.types.StringToStringsMap;
import org.jdesktop.beansbinding.Converter;
import static wsattacker.gui.component.testrequest.header.HttpHeader.stringToStringsMapToString;

/**
 * @author dev
 */
public class WsdlResponseToHeaderStringConverter
    extends Converter<WsdlResponse, String>
{

    private static final String HEADER_SPLIT_PATTERN = ": ";

    @Override
    public String convertForward( WsdlResponse response )
    {
        final StringToStringsMap headers = response.getResponseHeaders();
        return stringToStringsMapToString( headers );
    }

    @Override
    public WsdlResponse convertReverse( String headerText )
    {
        throw new IllegalStateException( "Read only" );
    }

}
