/**
 * WS-Attacker - A Modular Web Services Penetration Testing Framework Copyright
 * (C) 2010 Christian Mainka
 *
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 51
 * Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 */
package wsattacker.main.composition.plugin.option;

import wsattacker.gui.component.pluginconfiguration.composition.OptionGUI;
import wsattacker.gui.component.pluginconfiguration.option.OptionVarcharGUI_NB;

/**
 * WS-Attacker will represent this with a text input field.
 */
public abstract class AbstractOptionVarchar
    extends AbstractOptionString
{

    private static final long serialVersionUID = 2L;

    int maxLength;

    public AbstractOptionVarchar( String name, String value, int maxLength )
    {
        super( name, value );
        this.maxLength = maxLength;
    }

    public AbstractOptionVarchar( String name, String value, String description, int maxLength )
    {
        super( name, value, description );
        this.maxLength = maxLength;
    }

    public abstract int getMaxLength();

    public abstract void setMaxLength( int maxLength );

    @Override
    public OptionGUI createOptionGUI()
    {
        return new OptionVarcharGUI_NB( this );
    }
}
