/**
 * WS-Attacker - A Modular Web Services Penetration Testing Framework Copyright
 * (C) 2012 Andreas Falkenberg
 *
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 51
 * Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 */
package wsattacker.plugin.dos.dosExtension.gui;

import javax.swing.ImageIcon;
import wsattacker.plugin.dos.dosExtension.mvc.controller.AbortController;
import wsattacker.plugin.dos.dosExtension.mvc.controller.CloseAttackUnfinishedController;
import wsattacker.plugin.dos.dosExtension.mvc.controller.FinalizeController;
import wsattacker.plugin.dos.dosExtension.mvc.controller.StartController;
import wsattacker.plugin.dos.dosExtension.mvc.model.AttackModel;
import wsattacker.plugin.dos.dosExtension.mvc.view.AttackListener;
import wsattacker.plugin.dos.dosExtension.mvc.view.ProgressBarView;

/**
 * JFrame for attack status
 */
public class DosStatusFrame
    extends javax.swing.JFrame
{

    private AttackModel model;

    /**
     * Creates new form DosStatusJFrameNew
     */
    public DosStatusFrame( AttackModel model )
    {
        this.model = model;

        // init GUI - READ ONLY
        initComponents();

        // Add ViewElement to Model as listener
        // These listeners get updated once model gets updated
        this.model.addAttackListener( (AttackListener) jProgressBar1 );
        this.model.addAttackListener( jButtonAbort );
        this.model.addAttackListener( jButtonStart );
        this.model.addAttackListener( jButtonClose );
        this.model.addAttackListener( jButtonFinalize );
        this.model.addAttackListener( jLabelStatusView );
    }

    /**
     * This method is called from within the constructor to initialize the form. WARNING: Do NOT modify this code. The
     * content of this method is always regenerated by the Form Editor.
     */
    @SuppressWarnings( "unchecked" )
    // <editor-fold defaultstate="collapsed"
    // desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents()
    {

        jPanel1 = new javax.swing.JPanel();
        jProgressBar1 = new ProgressBarView( this.model );
        jLabelStatusView = new wsattacker.plugin.dos.dosExtension.mvc.view.StatusView( this.model );
        jLabelImage = new javax.swing.JLabel();
        jButtonClose = new wsattacker.plugin.dos.dosExtension.mvc.view.ButtonView( this.model, "Close", "close" );
        jButtonAbort = new wsattacker.plugin.dos.dosExtension.mvc.view.ButtonView( this.model, "Abort attack", "abort" );
        jButtonFinalize =
            new wsattacker.plugin.dos.dosExtension.mvc.view.ButtonView( this.model, "Finalize Attack", "finalize" );
        jButtonStart = new wsattacker.plugin.dos.dosExtension.mvc.view.ButtonView( this.model, "Start Attack", "start" );

        setDefaultCloseOperation( javax.swing.WindowConstants.DO_NOTHING_ON_CLOSE );
        addWindowListener( new java.awt.event.WindowAdapter()
        {
            @Override
            public void windowClosing( java.awt.event.WindowEvent evt )
            {
                formWindowClosing( evt );
            }
        } );

        jPanel1.setBorder( javax.swing.BorderFactory.createTitledBorder( null,
                                                                         "Attack Status",
                                                                         javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION,
                                                                         javax.swing.border.TitledBorder.DEFAULT_POSITION,
                                                                         null, java.awt.Color.black ) );

        jLabelStatusView.setText( "statusView1" );
        jLabelStatusView.setFont( new java.awt.Font( "Ubuntu", 0, 14 ) ); // NOI18N

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout( jPanel1 );
        jPanel1.setLayout( jPanel1Layout );
        jPanel1Layout.setHorizontalGroup( jPanel1Layout.createParallelGroup( javax.swing.GroupLayout.Alignment.LEADING ).addGroup( javax.swing.GroupLayout.Alignment.TRAILING,
                                                                                                                                   jPanel1Layout.createSequentialGroup().addContainerGap().addGroup( jPanel1Layout.createParallelGroup( javax.swing.GroupLayout.Alignment.TRAILING ).addComponent( jLabelStatusView,
                                                                                                                                                                                                                                                                                                   javax.swing.GroupLayout.DEFAULT_SIZE,
                                                                                                                                                                                                                                                                                                   javax.swing.GroupLayout.DEFAULT_SIZE,
                                                                                                                                                                                                                                                                                                   Short.MAX_VALUE ).addComponent( jProgressBar1,
                                                                                                                                                                                                                                                                                                                                   javax.swing.GroupLayout.DEFAULT_SIZE,
                                                                                                                                                                                                                                                                                                                                   315,
                                                                                                                                                                                                                                                                                                                                   Short.MAX_VALUE ) ).addContainerGap() ) );
        jPanel1Layout.setVerticalGroup( jPanel1Layout.createParallelGroup( javax.swing.GroupLayout.Alignment.LEADING ).addGroup( jPanel1Layout.createSequentialGroup().addContainerGap().addComponent( jProgressBar1,
                                                                                                                                                                                                       javax.swing.GroupLayout.PREFERRED_SIZE,
                                                                                                                                                                                                       javax.swing.GroupLayout.DEFAULT_SIZE,
                                                                                                                                                                                                       javax.swing.GroupLayout.PREFERRED_SIZE ).addPreferredGap( javax.swing.LayoutStyle.ComponentPlacement.UNRELATED ).addComponent( jLabelStatusView,
                                                                                                                                                                                                                                                                                                                                      javax.swing.GroupLayout.DEFAULT_SIZE,
                                                                                                                                                                                                                                                                                                                                      javax.swing.GroupLayout.DEFAULT_SIZE,
                                                                                                                                                                                                                                                                                                                                      Short.MAX_VALUE ).addContainerGap() ) );

        jLabelImage.setText( "" );
        java.net.URL imgURL = getClass().getResource( "/IMG/attack.png" );
        if ( imgURL != null )
        {
            jLabelImage.setIcon( new ImageIcon( imgURL, "DOS Lightning" ) );
        }
        else
        {
        }

        jButtonClose.setText( "Close" );
        jButtonClose.setToolTipText( "close GUI and cancel attack" );
        jButtonClose.addActionListener( new CloseAttackUnfinishedController( this.model ) );

        jButtonAbort.setText( "Abort Attack" );
        jButtonAbort.setToolTipText( "Stops the attack and all running attack threads, but leaves GUI open" );
        jButtonAbort.addActionListener( new AbortController( this.model ) );

        jButtonFinalize.setText( "Finalize Attack" );
        jButtonFinalize.setToolTipText( "Calculates the attack results" );
        jButtonFinalize.addActionListener( new FinalizeController( this.model ) );

        jButtonStart.setText( "Start Attack" );
        jButtonStart.setToolTipText( "Starts the attack!" );
        jButtonStart.addActionListener( new StartController( this.model ) );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout( getContentPane() );
        getContentPane().setLayout( layout );
        layout.setHorizontalGroup( layout.createParallelGroup( javax.swing.GroupLayout.Alignment.LEADING ).addGroup( layout.createSequentialGroup().addContainerGap().addComponent( jPanel1,
                                                                                                                                                                                    javax.swing.GroupLayout.PREFERRED_SIZE,
                                                                                                                                                                                    javax.swing.GroupLayout.DEFAULT_SIZE,
                                                                                                                                                                                    javax.swing.GroupLayout.PREFERRED_SIZE ).addPreferredGap( javax.swing.LayoutStyle.ComponentPlacement.RELATED ).addGroup( layout.createParallelGroup( javax.swing.GroupLayout.Alignment.LEADING ).addComponent( jButtonClose,
                                                                                                                                                                                                                                                                                                                                                                                                   javax.swing.GroupLayout.DEFAULT_SIZE,
                                                                                                                                                                                                                                                                                                                                                                                                   javax.swing.GroupLayout.DEFAULT_SIZE,
                                                                                                                                                                                                                                                                                                                                                                                                   Short.MAX_VALUE ).addComponent( jButtonAbort,
                                                                                                                                                                                                                                                                                                                                                                                                                                   javax.swing.GroupLayout.DEFAULT_SIZE,
                                                                                                                                                                                                                                                                                                                                                                                                                                   javax.swing.GroupLayout.DEFAULT_SIZE,
                                                                                                                                                                                                                                                                                                                                                                                                                                   Short.MAX_VALUE ).addComponent( jButtonFinalize,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                   javax.swing.GroupLayout.DEFAULT_SIZE,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                   187,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                   Short.MAX_VALUE ).addGroup( layout.createSequentialGroup().addComponent( jLabelImage ).addGap( 0,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  0,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  Short.MAX_VALUE ) ).addComponent( jButtonStart,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    javax.swing.GroupLayout.DEFAULT_SIZE,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    javax.swing.GroupLayout.DEFAULT_SIZE,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    Short.MAX_VALUE ) ).addContainerGap() ) );
        layout.setVerticalGroup( layout.createParallelGroup( javax.swing.GroupLayout.Alignment.LEADING ).addGroup( layout.createSequentialGroup().addContainerGap().addGroup( layout.createParallelGroup( javax.swing.GroupLayout.Alignment.LEADING ).addGroup( layout.createSequentialGroup().addComponent( jLabelImage ).addPreferredGap( javax.swing.LayoutStyle.ComponentPlacement.RELATED,
                                                                                                                                                                                                                                                                                                                                            81,
                                                                                                                                                                                                                                                                                                                                            Short.MAX_VALUE ).addComponent( jButtonStart,
                                                                                                                                                                                                                                                                                                                                                                            javax.swing.GroupLayout.PREFERRED_SIZE,
                                                                                                                                                                                                                                                                                                                                                                            javax.swing.GroupLayout.DEFAULT_SIZE,
                                                                                                                                                                                                                                                                                                                                                                            javax.swing.GroupLayout.PREFERRED_SIZE ).addPreferredGap( javax.swing.LayoutStyle.ComponentPlacement.UNRELATED ).addComponent( jButtonFinalize,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           javax.swing.GroupLayout.PREFERRED_SIZE,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           javax.swing.GroupLayout.DEFAULT_SIZE,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           javax.swing.GroupLayout.PREFERRED_SIZE ).addPreferredGap( javax.swing.LayoutStyle.ComponentPlacement.UNRELATED ).addComponent( jButtonAbort,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          javax.swing.GroupLayout.PREFERRED_SIZE,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          javax.swing.GroupLayout.DEFAULT_SIZE,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          javax.swing.GroupLayout.PREFERRED_SIZE ).addPreferredGap( javax.swing.LayoutStyle.ComponentPlacement.UNRELATED ).addComponent( jButtonClose,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         javax.swing.GroupLayout.PREFERRED_SIZE,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         javax.swing.GroupLayout.DEFAULT_SIZE,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         javax.swing.GroupLayout.PREFERRED_SIZE ) ).addComponent( jPanel1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  javax.swing.GroupLayout.DEFAULT_SIZE,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  javax.swing.GroupLayout.DEFAULT_SIZE,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  Short.MAX_VALUE ) ).addContainerGap() ) );

        jButtonStart.getAccessibleContext().setAccessibleName( "" );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void formWindowClosing( java.awt.event.WindowEvent evt )
    {// GEN-FIRST:event_formWindowClosing
     // TODO add your handling code here:
        model.closeAttackUnfinished();
    }// GEN-LAST:event_formWindowClosing

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private wsattacker.plugin.dos.dosExtension.mvc.view.ButtonView jButtonAbort;

    private wsattacker.plugin.dos.dosExtension.mvc.view.ButtonView jButtonClose;

    private wsattacker.plugin.dos.dosExtension.mvc.view.ButtonView jButtonFinalize;

    private wsattacker.plugin.dos.dosExtension.mvc.view.ButtonView jButtonStart;

    private javax.swing.JLabel jLabelImage;

    private wsattacker.plugin.dos.dosExtension.mvc.view.StatusView jLabelStatusView;

    private javax.swing.JPanel jPanel1;

    private javax.swing.JProgressBar jProgressBar1;
    // End of variables declaration//GEN-END:variables
}
