/**
 * WS-Attacker - A Modular Web Services Penetration Testing Framework Copyright
 * (C) 2013 Christian Altmeier
 *
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 51
 * Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 */
package wsattacker.plugin.intelligentdos.ui;

import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import javax.swing.JProgressBar;
import wsattacker.library.intelligentdos.common.AttackModel;
import wsattacker.plugin.intelligentdos.listener.AttackModelChangeListener;
import wsattacker.plugin.intelligentdos.ui.helper.FormatHelper;

/**
 * @author Christian Altmeier
 */
public class DoSStatusFrame
    extends javax.swing.JFrame
    implements AttackModelChangeListener
{

    /**
	 * 
	 */
    private static final long serialVersionUID = 1L;

    private transient AttackModel attackModel;

    private transient PropertyChangeListener listener;

    /**
     * Creates new form DoSStatusFrame
     */
    public DoSStatusFrame()
    {
        initComponents();
    }

    public AttackModel getAttackModel()
    {
        return attackModel;
    }

    /**
     * This method is called from within the constructor to initialize the form. WARNING: Do NOT modify this code. The
     * content of this method is always regenerated by the Form Editor.
     */
    @SuppressWarnings( "unchecked" )
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents()
    {

        jPanel1 = new javax.swing.JPanel();
        jProgressBar1 = new javax.swing.JProgressBar();
        jLabel6 = new javax.swing.JLabel();

        setDefaultCloseOperation( javax.swing.WindowConstants.DO_NOTHING_ON_CLOSE );

        jPanel1.setBorder( javax.swing.BorderFactory.createTitledBorder( "Attack Status" ) );

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout( jPanel1 );
        jPanel1.setLayout( jPanel1Layout );
        jPanel1Layout.setHorizontalGroup( jPanel1Layout.createParallelGroup( javax.swing.GroupLayout.Alignment.LEADING ).addGroup( jPanel1Layout.createSequentialGroup().addContainerGap().addGroup( jPanel1Layout.createParallelGroup( javax.swing.GroupLayout.Alignment.LEADING ).addComponent( jProgressBar1,
                                                                                                                                                                                                                                                                                                  javax.swing.GroupLayout.DEFAULT_SIZE,
                                                                                                                                                                                                                                                                                                  399,
                                                                                                                                                                                                                                                                                                  Short.MAX_VALUE ).addComponent( jLabel6,
                                                                                                                                                                                                                                                                                                                                  javax.swing.GroupLayout.DEFAULT_SIZE,
                                                                                                                                                                                                                                                                                                                                  javax.swing.GroupLayout.DEFAULT_SIZE,
                                                                                                                                                                                                                                                                                                                                  Short.MAX_VALUE ) ).addContainerGap() ) );
        jPanel1Layout.setVerticalGroup( jPanel1Layout.createParallelGroup( javax.swing.GroupLayout.Alignment.LEADING ).addGroup( jPanel1Layout.createSequentialGroup().addContainerGap().addComponent( jProgressBar1,
                                                                                                                                                                                                       javax.swing.GroupLayout.PREFERRED_SIZE,
                                                                                                                                                                                                       javax.swing.GroupLayout.DEFAULT_SIZE,
                                                                                                                                                                                                       javax.swing.GroupLayout.PREFERRED_SIZE ).addPreferredGap( javax.swing.LayoutStyle.ComponentPlacement.RELATED ).addComponent( jLabel6,
                                                                                                                                                                                                                                                                                                                                    javax.swing.GroupLayout.DEFAULT_SIZE,
                                                                                                                                                                                                                                                                                                                                    242,
                                                                                                                                                                                                                                                                                                                                    Short.MAX_VALUE ).addContainerGap() ) );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout( getContentPane() );
        getContentPane().setLayout( layout );
        layout.setHorizontalGroup( layout.createParallelGroup( javax.swing.GroupLayout.Alignment.LEADING ).addGroup( layout.createSequentialGroup().addContainerGap().addComponent( jPanel1,
                                                                                                                                                                                    javax.swing.GroupLayout.DEFAULT_SIZE,
                                                                                                                                                                                    javax.swing.GroupLayout.DEFAULT_SIZE,
                                                                                                                                                                                    Short.MAX_VALUE ).addContainerGap() ) );
        layout.setVerticalGroup( layout.createParallelGroup( javax.swing.GroupLayout.Alignment.LEADING ).addGroup( layout.createSequentialGroup().addContainerGap().addComponent( jPanel1,
                                                                                                                                                                                  javax.swing.GroupLayout.DEFAULT_SIZE,
                                                                                                                                                                                  javax.swing.GroupLayout.DEFAULT_SIZE,
                                                                                                                                                                                  Short.MAX_VALUE ).addContainerGap() ) );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel jLabel6;

    private javax.swing.JPanel jPanel1;

    private javax.swing.JProgressBar jProgressBar1;

    // End of variables declaration//GEN-END:variables
    @Override
    public void attackModelChanged( AttackModel attackModel )
    {
        // remove the listener from the previous attack to prevent side affects
        if ( this.attackModel != null )
        {
            this.attackModel.removePropertyChangeListener( getListener() );
        }
        this.attackModel = attackModel;

        // reset progressbar
        this.jProgressBar1.setValue( 0 );
        attackModel.addPropertyChangeListener( getListener() );

        jLabel6.setText( FormatHelper.toHTML( attackModel ) );
    }

    public JProgressBar getProgressBar()
    {
        return jProgressBar1;
    }

    private PropertyChangeListener getListener()
    {
        if ( listener == null )
        {
            listener = new PropertyChangeListener()
            {

                @Override
                public void propertyChange( PropertyChangeEvent evt )
                {
                    int progress = ( (AttackModel) evt.getSource() ).getProgress();
                    jProgressBar1.setValue( progress );
                }
            };
        }

        return listener;
    }

}
