/**
 * WS-Attacker - A Modular Web Services Penetration Testing Framework Copyright
 * (C) 2013 Christian Altmeier
 *
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 51
 * Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 */
package wsattacker.plugin.intelligentdos.ui.components;

import java.util.ArrayList;
import java.util.List;
import javax.swing.DefaultListModel;
import javax.swing.text.Document;
import wsattacker.plugin.intelligentdos.ui.helper.DefaultValidator;
import wsattacker.plugin.intelligentdos.ui.helper.JButtonStateController;
import wsattacker.plugin.intelligentdos.ui.helper.StringListValidator;

/**
 * @author Christian Altmeier
 */
public class ConfigureStringList_NB
    extends javax.swing.JPanel
{

    private final JButtonStateController jButtonStateController;

    private StringListValidator validator;

    /**
     * Creates new form ConfigureStringList_NB
     */
    public ConfigureStringList_NB()
    {
        initComponents();

        this.validator = new DefaultValidator();
        jButtonStateController = new JButtonStateController( addBtn );

        Document document = addTextField.getDocument();
        document.addDocumentListener( jButtonStateController );
    }

    public void setValidator( StringListValidator validator )
    {
        if ( validator == null )
        {
            throw new IllegalArgumentException( "null is not allowed as validator!" );
        }
        this.validator = validator;
        jButtonStateController.setValidator( validator );
    }

    public List<String> getStringList()
    {
        final DefaultListModel model = (DefaultListModel) jList1.getModel();

        List<String> list = new ArrayList<String>();
        for ( int i = 0; i < model.getSize(); i++ )
        {
            list.add( (String) model.get( i ) );
        }

        return list;
    }

    public void setStringList( List<String> strings )
    {
        final DefaultListModel model = (DefaultListModel) jList1.getModel();
        model.clear();

        for ( String string : strings )
        {
            model.addElement( string );
        }
    }

    /**
     * This method is called from within the constructor to initialize the form. WARNING: Do NOT modify this code. The
     * content of this method is always regenerated by the Form Editor.
     */
    @SuppressWarnings( "unchecked" )
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents()
    {

        jScrollPane1 = new javax.swing.JScrollPane();
        jList1 = new javax.swing.JList();
        addTextField = new javax.swing.JTextField();
        removeBtn = new javax.swing.JButton();
        jSeparator1 = new javax.swing.JSeparator();
        addBtn = new javax.swing.JButton();

        jList1.setModel( new DefaultListModel() );
        jList1.setSelectionMode( javax.swing.ListSelectionModel.SINGLE_SELECTION );
        jList1.addListSelectionListener( new javax.swing.event.ListSelectionListener()
        {
            public void valueChanged( javax.swing.event.ListSelectionEvent evt )
            {
                jList1ValueChanged( evt );
            }
        } );
        jScrollPane1.setViewportView( jList1 );

        addTextField.setToolTipText( "Valid xml string (e.g. <abc/>)" );

        removeBtn.setText( "remove" );
        removeBtn.setEnabled( false );
        removeBtn.addActionListener( new java.awt.event.ActionListener()
        {
            public void actionPerformed( java.awt.event.ActionEvent evt )
            {
                removeBtnActionPerformed( evt );
            }
        } );

        jSeparator1.setOrientation( javax.swing.SwingConstants.VERTICAL );

        addBtn.setText( "add" );
        addBtn.setEnabled( false );
        addBtn.addActionListener( new java.awt.event.ActionListener()
        {
            public void actionPerformed( java.awt.event.ActionEvent evt )
            {
                addBtnActionPerformed( evt );
            }
        } );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout( this );
        this.setLayout( layout );
        layout.setHorizontalGroup( layout.createParallelGroup( javax.swing.GroupLayout.Alignment.LEADING ).addGroup( layout.createSequentialGroup().addContainerGap().addGroup( layout.createParallelGroup( javax.swing.GroupLayout.Alignment.LEADING ).addComponent( jScrollPane1 ).addGroup( layout.createSequentialGroup().addComponent( removeBtn ).addPreferredGap( javax.swing.LayoutStyle.ComponentPlacement.RELATED ).addComponent( jSeparator1,
                                                                                                                                                                                                                                                                                                                                                                                                                                            javax.swing.GroupLayout.PREFERRED_SIZE,
                                                                                                                                                                                                                                                                                                                                                                                                                                            javax.swing.GroupLayout.DEFAULT_SIZE,
                                                                                                                                                                                                                                                                                                                                                                                                                                            javax.swing.GroupLayout.PREFERRED_SIZE ).addPreferredGap( javax.swing.LayoutStyle.ComponentPlacement.RELATED ).addComponent( addTextField,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         javax.swing.GroupLayout.DEFAULT_SIZE,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         90,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         Short.MAX_VALUE ).addPreferredGap( javax.swing.LayoutStyle.ComponentPlacement.RELATED ).addComponent( addBtn ) ) ).addContainerGap() ) );
        layout.setVerticalGroup( layout.createParallelGroup( javax.swing.GroupLayout.Alignment.LEADING ).addGroup( layout.createSequentialGroup().addContainerGap().addComponent( jScrollPane1,
                                                                                                                                                                                  javax.swing.GroupLayout.PREFERRED_SIZE,
                                                                                                                                                                                  85,
                                                                                                                                                                                  javax.swing.GroupLayout.PREFERRED_SIZE ).addPreferredGap( javax.swing.LayoutStyle.ComponentPlacement.RELATED ).addGroup( layout.createParallelGroup( javax.swing.GroupLayout.Alignment.LEADING,
                                                                                                                                                                                                                                                                                                                                       false ).addComponent( removeBtn ).addComponent( jSeparator1 ).addGroup( javax.swing.GroupLayout.Alignment.TRAILING,
                                                                                                                                                                                                                                                                                                                                                                                                               layout.createParallelGroup( javax.swing.GroupLayout.Alignment.BASELINE ).addComponent( addTextField,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      javax.swing.GroupLayout.PREFERRED_SIZE,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      javax.swing.GroupLayout.DEFAULT_SIZE,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      javax.swing.GroupLayout.PREFERRED_SIZE ).addComponent( addBtn ) ) ).addContainerGap( javax.swing.GroupLayout.DEFAULT_SIZE,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           Short.MAX_VALUE ) ) );
    }// </editor-fold>//GEN-END:initComponents

    private void removeBtnActionPerformed( java.awt.event.ActionEvent evt )
    {// GEN-FIRST:event_removeBtnActionPerformed
        int index = jList1.getSelectedIndex();
        if ( index != -1 )
        {
            final DefaultListModel model = (DefaultListModel) jList1.getModel();
            model.remove( index );
        }
    }// GEN-LAST:event_removeBtnActionPerformed

    private void addBtnActionPerformed( java.awt.event.ActionEvent evt )
    {// GEN-FIRST:event_addBtnActionPerformed
        final DefaultListModel model = (DefaultListModel) jList1.getModel();
        final String text = addTextField.getText();
        if ( validator.isValid( text ) )
        {
            model.addElement( text );
        }
    }// GEN-LAST:event_addBtnActionPerformed

    private void jList1ValueChanged( javax.swing.event.ListSelectionEvent evt )
    {// GEN-FIRST:event_jList1ValueChanged
        if ( evt.getValueIsAdjusting() == false )
        {

            if ( jList1.getSelectedIndex() == -1 )
            {
                // No selection, disable fire button.
                removeBtn.setEnabled( false );
            }
            else
            {
                // Selection, enable the fire button.
                removeBtn.setEnabled( true );
            }
        }
    }// GEN-LAST:event_jList1ValueChanged

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton addBtn;

    private javax.swing.JTextField addTextField;

    private javax.swing.JList jList1;

    private javax.swing.JScrollPane jScrollPane1;

    private javax.swing.JSeparator jSeparator1;

    private javax.swing.JButton removeBtn;

    // End of variables declaration//GEN-END:variables
}
