/**
 * WS-Attacker - A Modular Web Services Penetration Testing Framework Copyright
 * (C) 2013 Christian Altmeier
 *
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 51
 * Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 */
package wsattacker.plugin.intelligentdos.ui.dos;

import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.util.Arrays;
import java.util.List;
import wsattacker.library.intelligentdos.dos.XmlAttributeCount;
import wsattacker.library.intelligentdos.helper.IterateModel;

/**
 * @author Christian Altmeier
 */
public class ConfigureXmlAttributeCountDialog_NB
    extends javax.swing.JDialog
{

    private transient final XmlAttributeCount xmlAttributeCount;

    private boolean ok;

    /**
     * Creates new form ConfigureCoerceiveParsingDialog_NB
     * 
     * @param xmlAttributeCount
     */
    public ConfigureXmlAttributeCountDialog_NB( XmlAttributeCount xmlAttributeCount )
    {
        this.xmlAttributeCount = xmlAttributeCount;
        initComponents();

        final IterateModel numberOfTagsIterator = xmlAttributeCount.getNumberOfAttributesIterator();
        configureIterateModel_NB2.setStartAt( String.valueOf( numberOfTagsIterator.getStartAt() ) );
        configureIterateModel_NB2.setStopAt( String.valueOf( numberOfTagsIterator.getStopAt() ) );
        configureIterateModel_NB2.setIncrement( String.valueOf( numberOfTagsIterator.getIncrement() ) );
        configureIterateModel_NB2.setIterateStrategie( numberOfTagsIterator.getIterateStrategie() );

        List<String> names = Arrays.asList( xmlAttributeCount.getNames() );
        configureStringList_NB1.setStringList( names );
    }

    /**
     * This method is called from within the constructor to initialize the form. WARNING: Do NOT modify this code. The
     * content of this method is always regenerated by the Form Editor.
     */
    @SuppressWarnings( "unchecked" )
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents()
    {

        jLabel1 = new javax.swing.JLabel();
        jSeparator1 = new javax.swing.JSeparator();
        jButton1 = new javax.swing.JButton();
        jSeparator3 = new javax.swing.JSeparator();
        configureIterateModel_NB2 = new wsattacker.plugin.intelligentdos.ui.components.ConfigureIterateModel_NB();
        jSeparator2 = new javax.swing.JSeparator();
        jLabel2 = new javax.swing.JLabel();
        configureStringList_NB1 = new wsattacker.plugin.intelligentdos.ui.components.ConfigureStringList_NB();

        setDefaultCloseOperation( javax.swing.WindowConstants.DISPOSE_ON_CLOSE );

        jLabel1.setText( "Number of elements" );

        jButton1.setText( "OK" );
        jButton1.addActionListener( new java.awt.event.ActionListener()
        {
            @Override
            public void actionPerformed( java.awt.event.ActionEvent evt )
            {
                jButton1ActionPerformed( evt );
            }
        } );

        jLabel2.setText( "Number of elements" );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout( getContentPane() );
        getContentPane().setLayout( layout );
        layout.setHorizontalGroup( layout.createParallelGroup( javax.swing.GroupLayout.Alignment.LEADING ).addGroup( layout.createSequentialGroup().addContainerGap().addGroup( layout.createParallelGroup( javax.swing.GroupLayout.Alignment.LEADING ).addComponent( jSeparator1 ).addComponent( jSeparator3 ).addComponent( jSeparator2 ).addGroup( layout.createSequentialGroup().addGroup( layout.createParallelGroup( javax.swing.GroupLayout.Alignment.LEADING ).addComponent( jLabel1 ).addComponent( jButton1 ).addComponent( configureIterateModel_NB2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      javax.swing.GroupLayout.PREFERRED_SIZE,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      javax.swing.GroupLayout.DEFAULT_SIZE,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      javax.swing.GroupLayout.PREFERRED_SIZE ).addComponent( jLabel2 ).addComponent( configureStringList_NB1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     javax.swing.GroupLayout.PREFERRED_SIZE,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     javax.swing.GroupLayout.DEFAULT_SIZE,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     javax.swing.GroupLayout.PREFERRED_SIZE ) ).addGap( 0,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        0,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        Short.MAX_VALUE ) ) ).addContainerGap() ) );
        layout.setVerticalGroup( layout.createParallelGroup( javax.swing.GroupLayout.Alignment.LEADING ).addGroup( layout.createSequentialGroup().addContainerGap().addComponent( jLabel1 ).addPreferredGap( javax.swing.LayoutStyle.ComponentPlacement.RELATED ).addComponent( jSeparator1,
                                                                                                                                                                                                                                                                                javax.swing.GroupLayout.PREFERRED_SIZE,
                                                                                                                                                                                                                                                                                10,
                                                                                                                                                                                                                                                                                javax.swing.GroupLayout.PREFERRED_SIZE ).addPreferredGap( javax.swing.LayoutStyle.ComponentPlacement.RELATED ).addComponent( configureIterateModel_NB2,
                                                                                                                                                                                                                                                                                                                                                                                                             javax.swing.GroupLayout.PREFERRED_SIZE,
                                                                                                                                                                                                                                                                                                                                                                                                             javax.swing.GroupLayout.DEFAULT_SIZE,
                                                                                                                                                                                                                                                                                                                                                                                                             javax.swing.GroupLayout.PREFERRED_SIZE ).addPreferredGap( javax.swing.LayoutStyle.ComponentPlacement.RELATED ).addComponent( jLabel2 ).addPreferredGap( javax.swing.LayoutStyle.ComponentPlacement.RELATED ).addComponent( jSeparator2,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        javax.swing.GroupLayout.PREFERRED_SIZE,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        10,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        javax.swing.GroupLayout.PREFERRED_SIZE ).addPreferredGap( javax.swing.LayoutStyle.ComponentPlacement.RELATED ).addComponent( configureStringList_NB1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     javax.swing.GroupLayout.PREFERRED_SIZE,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     javax.swing.GroupLayout.DEFAULT_SIZE,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     javax.swing.GroupLayout.PREFERRED_SIZE ).addPreferredGap( javax.swing.LayoutStyle.ComponentPlacement.RELATED ).addComponent( jSeparator3,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  javax.swing.GroupLayout.PREFERRED_SIZE,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  10,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  javax.swing.GroupLayout.PREFERRED_SIZE ).addPreferredGap( javax.swing.LayoutStyle.ComponentPlacement.RELATED ).addComponent( jButton1 ).addContainerGap( javax.swing.GroupLayout.DEFAULT_SIZE,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           Short.MAX_VALUE ) ) );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jButton1ActionPerformed( java.awt.event.ActionEvent evt )
    {// GEN-FIRST:event_jButton1ActionPerformed
        setVisible( false );
        dispose();

        setIterateModel();
        setNames();

        ok = true;
    }// GEN-LAST:event_jButton1ActionPerformed

    private void setIterateModel()
    {
        int startAt = Integer.parseInt( configureIterateModel_NB2.getStartAt() );
        int stopAt = Integer.parseInt( configureIterateModel_NB2.getStopAt() );
        int increment = Integer.parseInt( configureIterateModel_NB2.getIncrement() );

        final IterateModel iterateModel =
            IterateModel.custom().startAt( startAt ).stopAt( stopAt ).setIncrement( increment ).setIterateStrategie( configureIterateModel_NB2.getIterateStrategie() ).build();

        xmlAttributeCount.setNumberOfAttributesIterator( iterateModel );
    }

    private void setNames()
    {
        final List<String> stringList = configureStringList_NB1.getStringList();
        String[] a = new String[stringList.size()];

        String[] names = stringList.toArray( a );
        xmlAttributeCount.setNames( names );
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private wsattacker.plugin.intelligentdos.ui.components.ConfigureIterateModel_NB configureIterateModel_NB2;

    private wsattacker.plugin.intelligentdos.ui.components.ConfigureStringList_NB configureStringList_NB1;

    private javax.swing.JButton jButton1;

    private javax.swing.JLabel jLabel1;

    private javax.swing.JLabel jLabel2;

    private javax.swing.JSeparator jSeparator1;

    private javax.swing.JSeparator jSeparator2;

    private javax.swing.JSeparator jSeparator3;

    // End of variables declaration//GEN-END:variables

    public boolean showDialog()
    {
        setModal( true );
        setVisible( true );

        addWindowFocusListener( new WindowAdapter()
        {

            @Override
            public void windowClosing( WindowEvent e )
            {
                ok = false;
            }
        } );

        return ok;
    }

}
