/**
 * WS-Attacker - A Modular Web Services Penetration Testing Framework Copyright
 * (C) 2013 Christian Altmeier
 *
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 51
 * Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 */
package wsattacker.plugin.intelligentdos.ui.dos;

import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import wsattacker.library.intelligentdos.dos.XmlOverlongNames;
import wsattacker.library.intelligentdos.helper.IterateModel;
import wsattacker.plugin.intelligentdos.ui.components.ConfigureIterateModel_NB;

/**
 * @author Christian Altmeier
 */
public class ConfigureXmlOverlongNamesDialog_NB
    extends javax.swing.JDialog
{

    /**
	 * 
	 */
    private static final long serialVersionUID = 1L;

    private transient final XmlOverlongNames xmlOverlongNames;

    private final CBChangeListener cbChangeListener = new CBChangeListener();

    private boolean ok;

    /**
     * Creates new form ConfigureCoerceiveParsingDialog_NB
     * 
     * @param xmlOverlongNames
     */
    public ConfigureXmlOverlongNamesDialog_NB( XmlOverlongNames xmlOverlongNames )
    {
        this.xmlOverlongNames = xmlOverlongNames;
        initComponents();

        cbElementName.addChangeListener( cbChangeListener );
        cbAttributeName.addChangeListener( cbChangeListener );
        cbAttributeValue.addChangeListener( cbChangeListener );

        final XmlOverlongNames.For[] overlogNamesFor = xmlOverlongNames.getOverlongNamesFor();
        for ( XmlOverlongNames.For what : overlogNamesFor )
        {
            switch ( what )
            {
                case ElementName:
                    cbElementName.setSelected( true );
                    break;
                case AttributeName:
                    cbAttributeName.setSelected( true );
                    break;
                case AttributeValue:
                    cbAttributeValue.setSelected( true );
                    break;
            }
        }

        iterateModelToComponent( xmlOverlongNames.getLengthOfStringsIterator(), lengthOfStrings );
        iterateModelToComponent( xmlOverlongNames.getNumberOfElementsIterator(), numberOfElements );
    }

    private void iterateModelToComponent( final IterateModel lengthOfStringsIterator, ConfigureIterateModel_NB comp )
    {
        comp.setStartAt( String.valueOf( lengthOfStringsIterator.getStartAt() ) );
        comp.setStopAt( String.valueOf( lengthOfStringsIterator.getStopAt() ) );
        comp.setIncrement( String.valueOf( lengthOfStringsIterator.getIncrement() ) );
        comp.setIterateStrategie( lengthOfStringsIterator.getIterateStrategie() );
    }

    /**
     * This method is called from within the constructor to initialize the form. WARNING: Do NOT modify this code. The
     * content of this method is always regenerated by the Form Editor.
     */
    @SuppressWarnings( "unchecked" )
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents()
    {

        jLabel4 = new javax.swing.JLabel();
        jSeparator4 = new javax.swing.JSeparator();
        jLabel1 = new javax.swing.JLabel();
        jSeparator1 = new javax.swing.JSeparator();
        jButton1 = new javax.swing.JButton();
        jSeparator3 = new javax.swing.JSeparator();
        lengthOfStrings = new wsattacker.plugin.intelligentdos.ui.components.ConfigureIterateModel_NB();
        cbElementName = new javax.swing.JCheckBox();
        cbAttributeName = new javax.swing.JCheckBox();
        cbAttributeValue = new javax.swing.JCheckBox();
        jLabel2 = new javax.swing.JLabel();
        jSeparator2 = new javax.swing.JSeparator();
        jLabel5 = new javax.swing.JLabel();
        jSeparator5 = new javax.swing.JSeparator();
        numberOfElements = new wsattacker.plugin.intelligentdos.ui.components.ConfigureIterateModel_NB();

        jLabel4.setText( "Length for the strings" );

        setDefaultCloseOperation( javax.swing.WindowConstants.DISPOSE_ON_CLOSE );

        jLabel1.setText( "Length for the strings" );

        jButton1.setText( "OK" );
        jButton1.setEnabled( isOkEnabled() );
        jButton1.addActionListener( new java.awt.event.ActionListener()
        {
            @Override
            public void actionPerformed( java.awt.event.ActionEvent evt )
            {
                jButton1ActionPerformed( evt );
            }
        } );

        cbElementName.setText( "element name" );

        cbAttributeName.setText( "attribute name" );

        cbAttributeValue.setText( "attribute value" );

        jLabel2.setText( "Overlong strings for" );

        jLabel5.setText( "Number of elements" );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout( getContentPane() );
        getContentPane().setLayout( layout );
        layout.setHorizontalGroup( layout.createParallelGroup( javax.swing.GroupLayout.Alignment.LEADING ).addGroup( layout.createSequentialGroup().addContainerGap().addGroup( layout.createParallelGroup( javax.swing.GroupLayout.Alignment.LEADING ).addComponent( jSeparator2 ).addComponent( jSeparator1 ).addComponent( jSeparator5 ).addComponent( jSeparator3 ).addGroup( layout.createSequentialGroup().addGroup( layout.createParallelGroup( javax.swing.GroupLayout.Alignment.LEADING ).addComponent( jLabel2 ).addComponent( jLabel1 ).addComponent( lengthOfStrings,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 javax.swing.GroupLayout.PREFERRED_SIZE,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 javax.swing.GroupLayout.DEFAULT_SIZE,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 javax.swing.GroupLayout.PREFERRED_SIZE ).addGroup( layout.createParallelGroup( javax.swing.GroupLayout.Alignment.LEADING ).addComponent( cbElementName ).addComponent( cbAttributeName ).addComponent( cbAttributeValue ) ).addComponent( jLabel5 ).addComponent( numberOfElements,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   javax.swing.GroupLayout.PREFERRED_SIZE,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   javax.swing.GroupLayout.DEFAULT_SIZE,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   javax.swing.GroupLayout.PREFERRED_SIZE ).addComponent( jButton1 ) ).addGap( 0,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               3,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               Short.MAX_VALUE ) ) ).addContainerGap() ) );
        layout.setVerticalGroup( layout.createParallelGroup( javax.swing.GroupLayout.Alignment.LEADING ).addGroup( javax.swing.GroupLayout.Alignment.TRAILING,
                                                                                                                   layout.createSequentialGroup().addContainerGap().addComponent( jLabel2 ).addPreferredGap( javax.swing.LayoutStyle.ComponentPlacement.RELATED ).addComponent( jSeparator2,
                                                                                                                                                                                                                                                                                javax.swing.GroupLayout.PREFERRED_SIZE,
                                                                                                                                                                                                                                                                                10,
                                                                                                                                                                                                                                                                                javax.swing.GroupLayout.PREFERRED_SIZE ).addPreferredGap( javax.swing.LayoutStyle.ComponentPlacement.RELATED ).addComponent( cbElementName ).addPreferredGap( javax.swing.LayoutStyle.ComponentPlacement.RELATED ).addComponent( cbAttributeName ).addPreferredGap( javax.swing.LayoutStyle.ComponentPlacement.RELATED ).addComponent( cbAttributeValue ).addGap( 18,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  18,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  18 ).addComponent( jLabel1 ).addPreferredGap( javax.swing.LayoutStyle.ComponentPlacement.RELATED ).addComponent( jSeparator1,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   javax.swing.GroupLayout.PREFERRED_SIZE,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   10,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   javax.swing.GroupLayout.PREFERRED_SIZE ).addPreferredGap( javax.swing.LayoutStyle.ComponentPlacement.RELATED ).addComponent( lengthOfStrings,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                javax.swing.GroupLayout.PREFERRED_SIZE,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                javax.swing.GroupLayout.DEFAULT_SIZE,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                javax.swing.GroupLayout.PREFERRED_SIZE ).addGap( 18,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 18,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 18 ).addComponent( jLabel5 ).addPreferredGap( javax.swing.LayoutStyle.ComponentPlacement.RELATED ).addComponent( jSeparator5,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  javax.swing.GroupLayout.PREFERRED_SIZE,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  10,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  javax.swing.GroupLayout.PREFERRED_SIZE ).addPreferredGap( javax.swing.LayoutStyle.ComponentPlacement.RELATED ).addComponent( numberOfElements,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               javax.swing.GroupLayout.PREFERRED_SIZE,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               javax.swing.GroupLayout.DEFAULT_SIZE,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               javax.swing.GroupLayout.PREFERRED_SIZE ).addGap( 18,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                18,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                18 ).addComponent( jSeparator3,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   javax.swing.GroupLayout.PREFERRED_SIZE,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   10,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   javax.swing.GroupLayout.PREFERRED_SIZE ).addPreferredGap( javax.swing.LayoutStyle.ComponentPlacement.RELATED ).addComponent( jButton1 ).addContainerGap( javax.swing.GroupLayout.DEFAULT_SIZE,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            Short.MAX_VALUE ) ) );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jButton1ActionPerformed( java.awt.event.ActionEvent evt )
    {// GEN-FIRST:event_jButton1ActionPerformed
        setVisible( false );
        dispose();

        setCollisionGenerators();
        xmlOverlongNames.setLengthOfStringsIterator( componentToIterateModel( lengthOfStrings ) );
        xmlOverlongNames.setNumberOfElementsIterator( componentToIterateModel( numberOfElements ) );

        ok = true;
    }// GEN-LAST:event_jButton1ActionPerformed

    private void setCollisionGenerators()
    {
        List<XmlOverlongNames.For> tmp = new ArrayList<XmlOverlongNames.For>();
        if ( cbElementName.isSelected() )
        {
            tmp.add( XmlOverlongNames.For.ElementName );
        }
        if ( cbAttributeName.isSelected() )
        {
            tmp.add( XmlOverlongNames.For.AttributeName );
        }
        if ( cbAttributeValue.isSelected() )
        {
            tmp.add( XmlOverlongNames.For.AttributeValue );
        }

        if ( tmp.isEmpty() )
        {
            throw new IllegalStateException( "no checkbox for collision checked!" );
        }

        XmlOverlongNames.For[] a = new XmlOverlongNames.For[tmp.size()];
        xmlOverlongNames.setOverlongNamesFor( tmp.toArray( a ) );
    }

    private IterateModel componentToIterateModel( ConfigureIterateModel_NB iterateComponent )
    {
        int startAt = Integer.parseInt( iterateComponent.getStartAt() );
        int stopAt = Integer.parseInt( iterateComponent.getStopAt() );
        int increment = Integer.parseInt( iterateComponent.getIncrement() );

        final IterateModel iterateModel =
            IterateModel.custom().startAt( startAt ).stopAt( stopAt ).setIncrement( increment ).setIterateStrategie( iterateComponent.getIterateStrategie() ).build();

        return iterateModel;
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JCheckBox cbAttributeName;

    private javax.swing.JCheckBox cbAttributeValue;

    private javax.swing.JCheckBox cbElementName;

    private javax.swing.JButton jButton1;

    private javax.swing.JLabel jLabel1;

    private javax.swing.JLabel jLabel2;

    private javax.swing.JLabel jLabel4;

    private javax.swing.JLabel jLabel5;

    private javax.swing.JSeparator jSeparator1;

    private javax.swing.JSeparator jSeparator2;

    private javax.swing.JSeparator jSeparator3;

    private javax.swing.JSeparator jSeparator4;

    private javax.swing.JSeparator jSeparator5;

    private wsattacker.plugin.intelligentdos.ui.components.ConfigureIterateModel_NB lengthOfStrings;

    private wsattacker.plugin.intelligentdos.ui.components.ConfigureIterateModel_NB numberOfElements;

    // End of variables declaration//GEN-END:variables

    public boolean showDialog()
    {
        setModal( true );
        setVisible( true );

        addWindowFocusListener( new WindowAdapter()
        {

            @Override
            public void windowClosing( WindowEvent e )
            {
                ok = false;
            }
        } );

        return ok;
    }

    private boolean isOkEnabled()
    {
        return ( cbElementName.isSelected() || cbAttributeName.isSelected() || cbAttributeValue.isSelected() );
    }

    private class CBChangeListener
        implements ChangeListener, Serializable
    {

        /**
		 * 
		 */
        private static final long serialVersionUID = 1L;

        @Override
        public void stateChanged( ChangeEvent e )
        {
            jButton1.setEnabled( isOkEnabled() );
        }

    }

}
