/**
 * WS-Attacker - A Modular Web Services Penetration Testing Framework Copyright
 * (C) 2013 Dennis Kupser
 *
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 51
 * Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 */

package wsattacker.plugin.xmlencryptionattack.gui;

import java.awt.Component;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.ListCellRenderer;
import javax.swing.UIManager;
import wsattacker.library.xmlencryptionattack.encryptedelements.AbstractEncryptionElement;

/**
 * @author Dennis
 */
public class PayloadListCellRenderer
    extends JLabel
    implements ListCellRenderer
{
    @Override
    public Component getListCellRendererComponent( JList list, Object value, int index, boolean isSelected,
                                                   boolean cellHasFocus )
    {
        AbstractEncryptionElement encPay = (AbstractEncryptionElement) value;

        this.setText( encPay.getEncryptedElement().getLocalName() );
        this.setOpaque( true );

        if ( isSelected )
        {
            this.setForeground( UIManager.getColor( "List.selectionForeground" ) );
            this.setBackground( UIManager.getColor( "List.selectionBackground" ) );
        }
        else
        {
            this.setForeground( UIManager.getColor( "List.Foreground" ) );
            this.setBackground( UIManager.getColor( "List.background" ) );
        }

        return this;

    }
}